#define LCD_RS   38         
#define LCD_WR   39     
#define LCD_CS   40       
#define LCD_REST 41

#define BUSY     7
#define DCLK     6
#define CS       5  
#define DIN      4 
#define DOUT     3
#define IRQ      2 

void Lcd_Writ_Bus(char VH,char VL)
{
  unsigned char i,temp,data; 
  data=VH;
  for(i=22;i<=29;i++)
  {
    temp=(data&0x01);
    if(temp)
      digitalWrite(i,HIGH);
    else
      digitalWrite(i,LOW);
    data=data>>1;
  }	 
  data=VL; 
  for(i=37;i>=30;i--)
  {
    temp=(data&0x01);
    if(temp)
      digitalWrite(i,HIGH);
    else
      digitalWrite(i,LOW);
    data=data>>1;
  }	
  digitalWrite(LCD_WR,LOW);
  digitalWrite(LCD_WR,HIGH);
}


void Lcd_Write_Com(char VH,char VL)  
{   
  digitalWrite(LCD_RS,LOW);
  Lcd_Writ_Bus(VH,VL);
}

void Lcd_Write_Data(char VH,char VL)
{
  digitalWrite(LCD_RS,HIGH);
  Lcd_Writ_Bus(VH,VL);
}

void Lcd_Write_Com_Data(int com,int dat)
{
     Lcd_Write_Com(com>>8,com);
     Lcd_Write_Data(dat>>8,dat);
}

void Address_set(unsigned int x1,unsigned int y1,unsigned int x2,unsigned int y2)
{
        Lcd_Write_Com(0x00,0x2a);
  	Lcd_Write_Data(0x00,x1>>8);	    //start X
  	Lcd_Write_Data(0x00,x1);	    //start X
  	Lcd_Write_Data(0x00,x2>>8);	    //end X
  	Lcd_Write_Data(0x00,x2);	    //end X
  	Lcd_Write_Com(0x00,0x2b);
  	Lcd_Write_Data(0x00,y1>>8);	    //start Y
  	Lcd_Write_Data(0x00,y1);	    //start Y
  	Lcd_Write_Data(0x00,y2>>8);	    //end Y
  	Lcd_Write_Data(0x00,y2);	    //end Y
  	Lcd_Write_Com(0x00,0x2c); 									 
}

void Lcd_Init(void)
{
       digitalWrite(LCD_REST,HIGH);
       delay(5); 
       digitalWrite(LCD_REST,LOW);
       delay(15);
       digitalWrite(LCD_REST,HIGH);
       delay(15);
	
    digitalWrite(LCD_CS,LOW); 
    
        Lcd_Write_Com(0x00,0xE9);
	Lcd_Write_Data(0x00,0x20);
	Lcd_Write_Com(0x00,0x11); //Exit Sleep
	delay(100);
	Lcd_Write_Com(0x00,0xD1);
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Data(0x00,0x71);
	Lcd_Write_Data(0x00,0x19);
	Lcd_Write_Com(0x00,0xD0);
	Lcd_Write_Data(0x00,0x07);
	Lcd_Write_Data(0x00,0x01);
	Lcd_Write_Data(0x00,0x08);
	Lcd_Write_Com(0x00,0x36);
	Lcd_Write_Data(0x00,0x48);
	Lcd_Write_Com(0x00,0x3A);
	Lcd_Write_Data(0x00,0x05);
	Lcd_Write_Com(0x00,0xC1);
	Lcd_Write_Data(0x00,0x10);
	Lcd_Write_Data(0x00,0x10);
	Lcd_Write_Data(0x00,0x02);
	Lcd_Write_Data(0x00,0x02);
	Lcd_Write_Com(0x00,0xC0); //Set Default Gamma
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Data(0x00,0x35);
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Data(0x00,0x01);
	Lcd_Write_Data(0x00,0x02);
	Lcd_Write_Com(0x00,0xC5); //Set frame rate
	Lcd_Write_Data(0x00,0x04);
	Lcd_Write_Com(0x00,0xD2); //power setting
	Lcd_Write_Data(0x00,0x01);
	Lcd_Write_Data(0x00,0x44);
	Lcd_Write_Com(0x00,0xC8); //Set Gamma
	Lcd_Write_Data(0x00,0x04);
	Lcd_Write_Data(0x00,0x67);
	Lcd_Write_Data(0x00,0x35);
	Lcd_Write_Data(0x00,0x04);
	Lcd_Write_Data(0x00,0x08);
	Lcd_Write_Data(0x00,0x06);
	Lcd_Write_Data(0x00,0x24);
	Lcd_Write_Data(0x00,0x01);
	Lcd_Write_Data(0x00,0x37);
	Lcd_Write_Data(0x00,0x40);
	Lcd_Write_Data(0x00,0x03);
	Lcd_Write_Data(0x00,0x10);
	Lcd_Write_Data(0x00,0x08);
	Lcd_Write_Data(0x00,0x80);
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Com(0x00,0x2A); 
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Data(0x00,0xeF);
	Lcd_Write_Com(0x00,0x2B); 
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Data(0x00,0x00);
	Lcd_Write_Data(0x00,0x01);
	Lcd_Write_Data(0x00,0x8F);
	Lcd_Write_Com(0x00,0x29); //display on      
	Lcd_Write_Com(0x00,0x2C); //display on
    
    digitalWrite(LCD_CS,HIGH); 
    

}

void Pant(char VH,char VL)
{
  int i,j;
  digitalWrite(LCD_CS,LOW); 
  Address_set(0,0,239,399);
  for(i=0;i<400;i++)
  {
    for (j=0;j<240;j++)
    {
      Lcd_Write_Data(VH,VL);
    }
 
  }
  digitalWrite(LCD_CS,HIGH);  
}

void setup()
{
  for(int p=22;p<42;p++)
  {
    pinMode(p,OUTPUT);
  }
  pinMode(DOUT,INPUT);
  pinMode(IRQ,INPUT);
  
  Lcd_Init();         
}
 
void loop()
{
   Pant(0xff, 0xff);
   delay(500);
   Pant(0x00, 0xff);
   delay(500);
   Pant(0xff, 0x00);
   delay(500);
}
